// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: The code below is basic on https://github.com/markushedvall/plantuml-encoder/blob/master/dist/plantuml-encoder.min.js. Credit to @markushedvall
// Please include the following in your index.html file
//
//   <script src="https://cdn.jsdelivr.net/npm/plantuml-encoder@1.4.0/dist/plantuml-encoder.min.js"></script>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("codemirror"), require("../addon/fold"), require("../addon/fold-code")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","codemirror","../addon/fold","../addon/fold-code"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.FoldCodeWithPlantUML = this.HyperMD.FoldCodeWithPlantUML || {}), CodeMirror, HyperMD.Fold, HyperMD.FoldCode);
})(function (require, exports, CodeMirror, fold_1, fold_code_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PlantUMLRenderer = void 0;
    CodeMirror = __importStar(CodeMirror);
    var PlantUMLRenderer = function (code, info) {
        var id = "_plantuml_id_" + Math.round(1e9 * Math.random()).toString(36);
        var el = document.createElement("div");
        el.style.margin = "8px";
        var encoded = window["plantumlEncoder"].encode(code);
        var url = "https://www.plantuml.com/plantuml/img/" + encoded;
        el.setAttribute("id", id);
        var img = document.createElement("img");
        img.src = url;
        el.appendChild(img);
        return {
            element: el,
            asyncRenderer: null,
        };
    };
    exports.PlantUMLRenderer = PlantUMLRenderer;
    if (window["plantumlEncoder"]) {
        CodeMirror.defineOption("plantuml", null, function (cm) {
            fold_code_1.getAddon(cm).clear("plantuml");
            fold_1.getAddon(cm).startFold();
        });
        fold_code_1.registerRenderer({
            name: "plantuml",
            pattern: /^(plantuml|puml)$/i,
            renderer: exports.PlantUMLRenderer,
            suggested: true,
        });
        if (window["ECHOMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-plantuml loaded.");
        }
    }
    else {
        if (window["ECHOMD_DEBUG"]) {
            console.log("[HyperMD] PowerPack fold-code-with-plantuml failed to load.\nPlease include\n\n  <script src=\"https://cdn.jsdelivr.net/npm/plantuml-encoder@1.4.0/dist/plantuml-encoder.min.js\"></script>\n\nin your HTML file");
        }
    }
});
