// HyperMD, copyright (c) by laobubu
// Distributed under an MIT license: http://laobubu.net/HyperMD/LICENSE
//
// POWERPACK for "addon/fold-emoji"
//
// Use [twemoji](https://github.com/twitter/twemoji) to render emoji `:smile:` :smile:
//
// :warning: **License**:
//
// Please follow https://github.com/twitter/twemoji#license if you use this powerpack.
// 使用前请注意阅读 twemoji 使用许可
//
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("twemoji"), require("../addon/fold-emoji")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","twemoji","../addon/fold-emoji"], mod) :
  /*plain env*/ mod(null, (this.HyperMD_PowerPack = this.HyperMD_PowerPack || {}, this.HyperMD_PowerPack["fold-emoji-with-twemoji"] = {}), twemoji, HyperMD.FoldEmoji);
})(function (require, exports, _twemoji_module, fold_emoji_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.twemojiRenderer = exports.twemojiChecker = exports.setOptions = void 0;
    _twemoji_module = __importStar(_twemoji_module);
    /** twemoji */
    var twemoji = _twemoji_module || this["twemoji"] || window["twemoji"];
    var twemojiOptions = null;
    /** set the 2nd argument of `twemoji.parse()` */
    function setOptions(options) {
        twemojiOptions = options;
    }
    exports.setOptions = setOptions;
    exports.twemojiChecker = fold_emoji_1.defaultChecker;
    var twemojiRenderer = function (text) {
        var emojiStr = fold_emoji_1.defaultDict[text];
        var html = twemojiOptions
            ? twemoji.parse(emojiStr, twemojiOptions)
            : twemoji.parse(emojiStr);
        // If twemoji failed to render, fallback to defaultRenderer
        if (!/^<img /i.test(html))
            return fold_emoji_1.defaultRenderer(text);
        var attr = /([\w-]+)="(.+?)"/g;
        var ans = document.createElement("img");
        var t;
        while ((t = attr.exec(html)))
            ans.setAttribute(t[1], t[2]);
        return ans;
    };
    exports.twemojiRenderer = twemojiRenderer;
    // Update default EmojiChecker and EmojiRenderer
    if (typeof twemoji !== "undefined") {
        fold_emoji_1.defaultOption.emojiChecker = exports.twemojiChecker;
        fold_emoji_1.defaultOption.emojiRenderer = exports.twemojiRenderer;
    }
    else {
        if (window["ECHOMD_DEBUG"]) {
            console.error("[HyperMD] PowerPack fold-emoji-with-twemoji loaded, but twemoji not found.");
        }
    }
});
